<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Orders</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
  <div class="wrapper">

    <!-- Preloader -->

    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Devcamp 120</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Vũ Duy Dũng</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="#" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Order</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Order</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Order</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <h3 class="text-center text-primary">Quản trị Order</h3>
          <div class="jumbotron container">
            <div class="row form-group">
              <label for="" class="col-sm-3">Chọn khách hàng</label>
              <div class="col-sm-9">
                <select name="select-department" id="select-department" class="form-control">
                  <option value="none">Tên khách hàng</option>
                </select>
              </div>
            </div>
            <div class="row form-group">
              <label for="" class="col-sm-3">Order Code</label>
              <div class="col-sm-9">
                <input id="inp-employee-code" type="text" class="form-control" placeholder="Order Code">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Pizza Size</label>
              <div class="col-sm-9">
                <input id="inp-employee-name" type="text" class="form-control" placeholder="Pizza size">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Pizza Type</label>
              <div class="col-sm-9">
                <input id="inp-link" type="text" class="form-control" placeholder="Pizza Type">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Voucher Code</label>
              <div class="col-sm-9">
                <input id="inp-position" type="text" class="form-control" placeholder="Voucher Code">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Thành tiền</label>
              <div class="col-sm-9">
                <input id="inp-price" type="text" class="form-control" placeholder="Thành tiền">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Ngày tạo</label>
              <div class="col-sm-9">
                <input id="inp-ngay-tao" type="text" class="form-control" placeholder="Ngày tạo">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Ngày cập nhật</label>
              <div class="col-sm-9">
                <input id="inp-cap-nhat" type="text" class="form-control" placeholder="Ngày cập nhật">
              </div>
            </div>

            <div class="mb-3 d-flex justify-content-around">
              <button id="btn-add" class="btn btn-success"><i class="fas fa-plus"></i>&nbsp;Thêm khách hàng</button>
              <button id="btn-update" class="btn btn-primary"><i class="fas fa-users-cog"></i>&nbsp;Cập nhật khách hàng</button>
              <button id="btn-delete" class="btn btn-danger"><i class="fas fa-trash"></i>&nbsp;Xóa khách hàng</button>
              <button id="btn-delete-all" class="btn btn-danger"><i class="fas fa-trash-alt"></i>&nbsp;Xóa tất cả khách hàng</button>
            </div>
            <div class="d-flex justify-content-around">
              <button id="btn-add-employee" class="btn btn-success"><i class="fas fa-user-plus"></i>&nbsp;Thêm order</button>
              <button id="btn-update-employee" class="btn btn-primary"><i class="fas fa-user-edit"></i>&nbsp;Cập nhật
                order</button>
              <button id="btn-delete-employee" class="btn btn-danger"><i class="fas fa-user-times"></i>&nbsp;Xóa order</button>
            </div>


          </div>

          <table id="table-employees" class="table table-bordered table-stripped table-hover">
            <thead>
              <tr>
                <th>STT</th>
                <th>Order Code</th>
                <th>Pizza Size</th>
                <th>Pizza Type</th>
                <th>Voucher Code</th>
                <th>Thành Tiền</th>
                <th>Phải Trả</th>
                <th>Ngày tạo</th>
                <th>Ngày cập nhật</th>
              </tr>
            </thead>
            <tbody></tbody>
          </table>
          <!-- Modal Thêm phòng ban -->
          <div class="modal fade" id="modal-add-department" tabindex="-1" role="dialog"
            aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title font-weight-bold" id="exampleModalLabel">Thêm chương</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="row form-group">
                    <lablel class="col-sm-4 font-weight-bold">Mã Chương</lablel>
                    <div class="col-sm-8">
                      <input id="inp-department-code-add" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Tên Chương</lable>
                    <div class="col-sm-8">
                      <input id="inp-department-name-add" type="text" class="form-control">
                    </div>
                  </div>


                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Giới thiệu</lable>
                    <div class="col-sm-8">
                      <input id="inp-introduce-add" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Người dịch</lable>
                    <div class="col-sm-8">
                      <input id="inp-translater-add" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Trang</lable>
                    <div class="col-sm-8">
                      <input id="inp-page-add" type="number" class="form-control">
                    </div>
                  </div>
                </div>
                <div class="modal-footer">
                  <button id="btn-confirm-add" type="button" class="btn btn-success">Thêm mới</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                </div>
              </div>
            </div>
          </div>

          <!-- Modal cập nhật thông tin phòng ban -->
          <div class="modal fade" id="modal-update-department" tabindex="-1" role="dialog"
            aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title font-weight-bold" id="exampleModalLabel">Cập nhật Chương</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="row form-group">
                    <lablel class="col-sm-4 font-weight-bold">Mã Chương</lablel>
                    <div class="col-sm-8">
                      <input id="inp-department-code-update" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Tên Chương</lable>
                    <div class="col-sm-8">
                      <input id="inp-department-name-update" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Giới thiệu</lable>
                    <div class="col-sm-8">
                      <input id="inp-introduce-update" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Người dịch</lable>
                    <div class="col-sm-8">
                      <input id="inp-translater-update" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Trang</lable>
                    <div class="col-sm-8">
                      <input id="inp-page-update" type="text" class="form-control">
                    </div>
                  </div>
                </div>
                <div class="modal-footer">
                  <button id="btn-confirm-update" type="button" class="btn btn-primary">Cập nhật</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </section>
      <!-- /.content -->

      <!-- Modal delete phòng ban -->
      <div class="modal fade" id="modal-delete-department" tabindex="-1" role="dialog"
        aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h5>Bạn có chắc chắn muốn xóa chương sách này?</h5>
            </div>
            <div class="modal-footer">
              <button id="btn-confirm-delete" type="button" class="btn btn-danger">Xác nhận</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
          </div>
        </div>
      </div>

      <!-- Modal delete tất cả phòng ban -->
      <div class="modal fade" id="modal-delete-all-department" tabindex="-1" role="dialog"
        aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h5>Bạn có chắc chắn muốn tất cả chương sách?</h5>
            </div>
            <div class="modal-footer">
              <button id="btn-confirm-delete-all" type="button" class="btn btn-danger">Xác nhận</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
          </div>
        </div>
      </div>

      <!-- Modal xóa thông tin nhân viên -->
      <div class="modal fade" id="modal-delete-employee" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h5>Bạn có chắc chắn muốn xóa bài viết này không?</h5>
            </div>
            <div class="modal-footer">
              <button id="btn-confirm-delete-employee" type="button" class="btn btn-danger">Xác nhận</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- /.content-wrapper -->
    <footer class="main-footer">
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 3.2.0
      </div>
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->

  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gListCol = ["id", "maBai", "tenBai", "trang", "gioiThieu"];
    const gCOL_ID = 0;
    const gCOL_MA_BAI = 1;
    const gCOL_TEN_BAI = 2;
    const gCOL_TRANG = 3;
    const gCOL_GIOI_THIEU = 4;

    var gTableEmployee = $("#table-employees").DataTable({
      columns: [
        { data: gListCol[gCOL_ID] },
        { data: gListCol[gCOL_MA_BAI] },
        { data: gListCol[gCOL_TEN_BAI] },
        { data: gListCol[gCOL_TRANG] },
        { data: gListCol[gCOL_GIOI_THIEU] }
      ],
      columnDefs: [
        {
          targets: gCOL_ID,
          render: function () {
            return gStt++;
          }
        }
      ]
    });
    // Biến toàn cục để lưu số thứ tự
    var gStt = 1;
    // Biến lưu id của nhân viên
    var gBaiId = null;
    // Biến lưu id của phòng ban
    var gChuongId = null;
    // Biến lưu toàn bộ phòng ban
    var gListChuong = null;
    // Biến để lưu toàn bộ nhân viên
    var gListBai = null;
    // Biến để lưu hành động thực hiện với department
    var gActionChuong = null;
    // Biến để lưu hành động thực hiện với employee
    var gActionBaiViet = null;
    // Biến hành động tạo mới
    const gACTION_CREATE = "create";
    // Biến hành động cập nhật
    const gACTION_UPDATE = "update";


    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    // Thực thi sự kiện tải trang
    onPageLoading();

    // Thực thi sự kiện thay đổi phòng ban
    $("#select-department").on("change", function () {
      gChuongId = $("#select-department").val();
      callApiLoadToLoadListBaiVietToTable();
    });

    // Thực thi sự kiện nhấn vào row trong datatable
    $("#table-employees").on("click", "tr", function () {
      onClickTableRow(this);
    });


    // Thực thi sự kiện nhấn nút thêm mới phòng ban
    $("#btn-add").on("click", function () {
      $("#modal-add-department").modal("show");
    });


    // Hàm thực thi sự kiện nhấn nút thêm mới trong modal thêm mới phòng ban
    $("#btn-confirm-add").on("click", function () {
      onBtnCreateNewChuong();
    });

    // Thực thi sự kiện nhấn nút cập nhật phòng ban
    $("#btn-update").on("click", function () {
      onBtnUpdateDepartmentClick();
    });

    // Thực thi sự kiện nhấn nút confirm update trong modal
    $("#btn-confirm-update").on("click", function () {
      onBtnConfirmUpdateClick();
    });

    // Thực thi sự kiện nhấn nút xóa phòng ban
    $("#btn-delete").on("click", function () {
      onBtnDeleteDepartmentClick();
    });

    // Thực thi sự kiện nhấn nút xác nhận xóa phòng ban trong modal delete
    $("#btn-confirm-delete").on("click", function () {
      callApiToDeleteChuong();
    });

    // Thực thi sự kiện nhấn nút xóa tất cả phòng ban
    $("#btn-delete-all").on("click", function () {
      $("#modal-delete-all-department").modal("show");
    });

    // Thực thi sự kiện nhấn nút confirm xóa tất cả phòng ban
    $("#btn-confirm-delete-all").on("click", function () {
      onBtnConfirmDeleteAllUserClick();
    });

    // Thực thi sự kiện nhấn nút thêm mới nhân viên
    $("#btn-add-employee").on("click", function () {
      // Kiểm tra xem đã chọn phòng ban chưa
      if (checkSelectAlbum()) {
        onBtnCreateNewBaiVietClick();
      }
    });

    // Thực thi sự kiện nhấn nút cập nhật thông tin nhân viên
    $("#btn-update-employee").on("click", function () {
      if (checkSelectAlbum) {
        if (gBaiId != null) {
          onBtnUpdateBaiVietClick();
        }
        else {
          alert("Vui lòng chọn nhân viên muốn cập nhật thông tin!");
        }
      }
    });

    // Thực thi sự kiện nhấn nút xóa nhân viên
    $("#btn-delete-employee").on("click", function () {
      if (gBaiId != null) {
        $("#modal-delete-employee").modal("show");
      }
      else {
        alert("Vui lòng chọn nhân viên muốn xóa!");
      }
    });

    // Thực thi sự kiện nhấn nút xác nhận xóa trong modal delete nhân viên
    $("#btn-confirm-delete-employee").on("click", function () {
      onBtnConfirmDeleteBaiVietClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      callApiToLoadListChuongToSelectChuong();
      callApiToGetListBaiViet();
    }

    // Hàm xử lý sự kiện nhấn vào row trong table
    // Khi nhấn vào row thì lấy dữ liệu ra và điền vào form
    function onClickTableRow(paramRow) {
      var vDataRow = gTableEmployee.row(paramRow).data();
      gBaiId = vDataRow.id;
      // Gọi hàm load dữ liệu row vào form
      loadBaiVietDataToForm(vDataRow);
    }

    // Hàm xử lý sự kiện nhấn nút thêm phòng ban trong modal thêm mới
    function onBtnCreateNewChuong() {
      gActionChuong = gACTION_CREATE;
      var vNewChuong = {
        maChuong: "",
        tenChuong: "",
        gioiThieu: "",
        tenNguoiDich: "",
        trang: ""
      }
      // Gọi hàm lấy giá trị insert phòng ban
      getNewChuongData(vNewChuong);
      console.log(vNewChuong);
      // validate dữ liệu
      var vValidate = validateAlbumData(vNewChuong);
      if (vValidate) {
        // Gọi APi để thêm mới phòng ban
        callApiToCreateNewChuong(vNewChuong);
      }
    }

    // Hàm xử lý sự kiện nhấn nút cập nhật phòng ban
    function onBtnUpdateDepartmentClick() {
      if (checkSelectAlbum()) {
        $("#modal-update-department").modal("show");
        callApiToGetChuongDataById();
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa phòng ban 
    function onBtnDeleteDepartmentClick() {
      if (checkSelectAlbum()) {
        $("#modal-delete-department").modal("show");
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa nhân viên

    // Hàm xử lý sự kiện nhấn nút xác nhận xóa tất cả phòng ban trong modal xóa tất cả
    function onBtnConfirmDeleteAllUserClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/users",
        success: function (paramRes) {
          alert("Tất cả user đã được xóa!");
          $("#modal-delete-all-user").modal("hide");
          callApiToLoadListChuongToSelectChuong();
        },
        error: function (paramError) {
          alert("Xóa tất cả chương thất bại, vui lòng thử lại!");
          $("#modal-delete-all-department").modal("hide");
          console.log(paramError.status);
        }
      })
    }

    // Hàm xử lý sự kiện nhấn nút cập nhật phòng ban trong modal
    function onBtnConfirmUpdateClick() {
      gActionChuong = gACTION_UPDATE;
      var vChuong = {
        maChuong: "",
        tenChuong: "",
        gioiThieu: "",
        tenNguoiDich: "",
        trang: ""
      }
      // Gọi hàm lấy giá trị phòng ban update
      getDataUpdateAlbum(vChuong);
      console.log(vChuong);
      // validate dữ liệu
      var vValidate = validateAlbumData(vChuong);
      if (vValidate) {
        // Gọi APi để thêm mới phòng ban
        callApiToUpdateChuong(vChuong);
      }
    }

    // Hàm xử lý sự kiện nhấn nút tạo mới nhân viên
    function onBtnCreateNewBaiVietClick() {
      gActionBaiViet = gACTION_CREATE;
      var vNewBaiViet = {
        maBai: "",
        tenBai: "",
        gioiThieu: "",
        trang: "",
      }
      getBaiVietDataForm(vNewBaiViet);
      console.log(vNewBaiViet);
      var vValidate = validateBaiVietData(vNewBaiViet);
      if (vValidate) {
        callApiToCreateNewBaiViet(vNewBaiViet);
      }
    }

    // Hàm xử lý sự kiện nhấn nút update nhân viên
    function onBtnUpdateBaiVietClick() {
      gActionBaiViet = gACTION_UPDATE;
      var vBaiViet = {
        maBai: "",
        tenBai: "",
        gioiThieu: "",
        trang: ""
      }
      getBaiVietDataForm(vBaiViet);
      console.log(vBaiViet);
      var vValidate = validateBaiVietData(vBaiViet);
      if (vValidate) {
        callApiToUpdateBaiViet(vBaiViet);
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa một nhân viên
    function onBtnConfirmDeleteBaiVietClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/bai/" + gBaiId,
        success: function (paramRes) {
          alert("Xóa bài viết thành công!");
          $("#modal-delete-employee").modal("hide");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          callApiLoadToLoadListBaiVietToTable();
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListBaiViet();
          // Reset lại form
          resetFormEmployee();
        },
        error: function (paramError) {
          console.log(paramError.status);
          alert("Xóa bài viết thất bại, vui lòng thử lại!");
          $("#modal-delete-employee").modal("hide");
        }
      })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm gọi API để lấy ra danh sách phòng ban đưa vào thẻ select
    function callApiToLoadListChuongToSelectChuong() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/chuongs",
        success: function (paramRes) {
          console.log(paramRes);
          gListChuong = paramRes;
          loadDataToSelectAlbum(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để lấy danh sách toàn bộ nhân viên
    function callApiToGetListBaiViet() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/bais",
        success: function (paramRes) {
          gListBai = paramRes;
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu vào thẻ select Department
    function loadDataToSelectAlbum(paramDataAlbum) {
      var vSelectAlbum = $("#select-department");
      vSelectAlbum.html("");
      $("<option>", {
        value: "none",
        text: "Chọn chương"
      }).appendTo(vSelectAlbum);
      for (var bI = 0; bI < paramDataAlbum.length; bI++) {
        $("<option>", {
          value: paramDataAlbum[bI].id,
          text: paramDataAlbum[bI].tenChuong
        }).appendTo(vSelectAlbum);
      }
    }

    // Hàm call Api load ra danh sách nhân viên khi chọn phòng ban
    function callApiLoadToLoadListBaiVietToTable() {
      var vBaiId = $("#select-department").val();
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/chuong/" + vBaiId + "/bais",
        success: function (paramRes) {
          loadDataToTable(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu vào bảng nhân viên
    function loadDataToTable(paramBaiVietData) {
      gStt = 1;
      gTableEmployee.clear();
      gTableEmployee.rows.add(paramBaiVietData);
      gTableEmployee.draw();
    }

    // Hàm load thông tin nhân viên vào fomr
    function loadBaiVietDataToForm(paramBaiVietData) {
      $("#inp-employee-code").val(paramBaiVietData.maBai);
      $("#inp-employee-name").val(paramBaiVietData.tenBai);
      $("#inp-link").val(paramBaiVietData.trang);
      $("#inp-position").val(paramBaiVietData.gioiThieu);
    }

    // Hàm chỉnh lại form của ngày tháng cho phù hợp
    function formatDate(paramDate) {
      // tách ra từng phần thông qua hàm split, sau đó sắp xếp theo kiểu của input date là yy-MM-dd"
      var vListDate = paramDate.split("-");
      return vListDate[2] + "-" + vListDate[1] + "-" + vListDate[0];
    }

    // Hàm lấy thông tin phòng ban thêm mới
    function getNewChuongData(paramDataChuong) {
      paramDataChuong.maChuong = $("#inp-department-code-add").val();
      paramDataChuong.tenChuong = $("#inp-department-name-add").val();
      paramDataChuong.gioiThieu = $("#inp-introduce-add").val();
      paramDataChuong.tenNguoiDich = $("#inp-translater-add").val();
      paramDataChuong.trang = $("#inp-page-add").val();
    }

    // Hàm validate dữ liệu phòng ban
    function validateAlbumData(paramDataAlbum) {
      if (paramDataAlbum.maChuong == "") {
        alert("Vui lòng nhập mã chương!");
        return false;
      }
      // Gọi hàm kiểm tra mã phòng ban có tồn tại hay chưa
      if (checkDuplicateMaChuong(paramDataAlbum.maChuong)) {
        alert("Mã album đã tồn tại!")
        return false;
      }

      if (paramDataAlbum.tenChuong == "") {
        alert("Vui lòng nhập tên chương!");
        return false;
      }

      if (paramDataAlbum.gioiThieu == "") {
        alert("Vui lòng giới thiệu chương!");
        return false;
      }

      if (paramDataAlbum.tenNguoiDich == "") {
        alert("Vui lòng nhập tên người dịch!");
        return false;
      }

      if (paramDataAlbum.trang == "") {
        alert("Vui lòng nhập trang của chương!");
        return false;
      }
      return true;
    }

    // Hàm gọi API để tạo mới 1 phòng ban
    function callApiToCreateNewChuong(paramDataChuong) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/chuongs",
        contentType: "application/json",
        data: JSON.stringify(paramDataChuong),
        success: function (paramRes) {
          alert("Thêm mới chương thành công!");
          callApiToLoadListChuongToSelectChuong();
          $("#modal-add-department").modal("hide");
          resetFormCreateNewDepartment();
        },
        error: function (paramError) {
          alert("Tạo mới chương thất bại, vui lòng thử lại");
          $("#modal-add-department").modal("hide");
          console.log(paramError.status);
        }
      })
    }

    // Hàm lấy giá trị phòng ban trong modal update
    function getDataUpdateAlbum(paramDataDepartment) {
      paramDataDepartment.maChuong = $("#inp-department-code-update").val().trim();
      paramDataDepartment.tenChuong = $("#inp-department-name-update").val().trim();
      paramDataDepartment.gioiThieu = $("#inp-introduce-update").val().trim();
      paramDataDepartment.tenNguoiDich = $("#inp-translater-update").val().trim();
      paramDataDepartment.trang = $("#inp-page-update").val().trim();
    }

    // Hàm gọi API để lấy dữ liệu phòng ban thông qua ID
    function callApiToGetChuongDataById() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/chuong/" + gChuongId,
        success: function (paramRes) {
          loadAlbumDataToFormUpdate(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      })
    }

    // Hàm load dữ liệu phòng ban vào form update
    function loadAlbumDataToFormUpdate(paramDataChuong) {
      $("#inp-department-code-update").val(paramDataChuong.maChuong);
      $("#inp-department-name-update").val(paramDataChuong.tenChuong);
      $("#inp-introduce-update").val(paramDataChuong.gioiThieu);
      $("#inp-translater-update").val(paramDataChuong.tenNguoiDich);
      $("#inp-page-update").val(paramDataChuong.trang);

    }

    // Hàm gọi API để cập nhật thông tin phòng ban
    function callApiToUpdateChuong(paramDataChuong) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/chuong/" + gChuongId,
        contentType: "application/json",
        data: JSON.stringify(paramDataChuong),
        success: function (paramRes) {
          alert("Cập nhật chương thành công!");
          callApiToLoadListChuongToSelectChuong();
          $("#modal-update-department").modal("hide");
        },
        error: function (paramError) {
          alert("Cập nhật chương thất bại, vui lòng thử lại");
          $("#modal-update-department").modal("hide");
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để xóa 1 phòng ban thông qua ID
    function callApiToDeleteChuong() {
      console.log(gChuongId);
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/chuong/" + gChuongId,
        success: function (paramRes) {
          alert("Xóa chương thành công!");
          callApiToLoadListChuongToSelectChuong();
          $("#modal-delete-department").modal("hide");
          resetFormEmployee();
        },
        error: function (paramError) {
          alert("Xóa chương thất bại, vui lòng thử lại");
          $("#modal-delete-department").modal("hide");
          console.log(paramError.status);
        }
      });
    }

    // Hàm reset form tạo mới phòng ban
    function resetFormCreateNewDepartment() {
      $("#inp-department-code-add").val("");
      $("#inp-department-name-add").val("");
      $("#inp-translater-add").val("");
      $("#inp-page-add").val("");
      $("#inp-introduce-add").val("");
    }

    // Hàm lấy thông tin nhân viên thêm mới
    function getBaiVietDataForm(paramBaiVietData) {
      paramBaiVietData.maBai = $("#inp-employee-code").val().trim();
      paramBaiVietData.tenBai = $("#inp-employee-name").val().trim();
      paramBaiVietData.gioiThieu = $("#inp-position").val().trim();
      paramBaiVietData.trang = $("#inp-link").val().trim();
    }

    // Hàm kiểm tra đã chọn phòng ban hay chưa
    function checkSelectAlbum() {
      var vDepartmentId = $("#select-department").val();
      if (vDepartmentId == "none") {
        alert("Vui lòng chọn chương");
        return false;
      }
      else {
        gChuongId = vDepartmentId;
        return true;
      }
    }

    // Hàm validate dữ liệu employee
    function validateBaiVietData(paramBaiVietData) {
      if (paramBaiVietData.maBai == "") {
        alert("Vui lòng nhập mã bài!");
        return false;
      }
      // Gọi hàm kiểm tra xem mã nhân viên có bị trùng hay không
      if (checkDuplicateMaBai(paramBaiVietData.maBai)) {
        alert("Mã bài đã tồn tại!");
        return false;
      }

      if (paramBaiVietData.tenBai == "") {
        alert("Vui lòng nhập tên bài!");
        return false;
      }
      if (paramBaiVietData.gioiThieu == "") {
        alert("Vui lòng nhập lời giới thiệu bài viết!");
        return false;
      }
      if (paramBaiVietData.trang == "") {
        alert("Vui lòng nhập trang bài viết!");
        return false;
      }
      return true;
    }

    // Hàm gọi API để thêm mới 1 nhân viên
    function callApiToCreateNewBaiViet(paramBaiViet) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/chuong/" + gChuongId + "/bais",
        contentType: "application/json",
        data: JSON.stringify(paramBaiViet),
        success: function (paramRes) {
          alert("Thêm bài viết thành công!");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          callApiLoadToLoadListBaiVietToTable();
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListBaiViet();
          // Reset lại form
          resetFormEmployee();
        },
        error: function (paramError) {
          alert("Thêm bài viết thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để cập nhật thông tin 1 nhân viên
    function callApiToUpdateBaiViet(paramBaiVietData) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/chuong/" + gChuongId + "/bai/" + gBaiId,
        contentType: "application/json",
        data: JSON.stringify(paramBaiVietData),
        success: function (paramRes) {
          alert("Cập nhật bài viết thành công!");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          callApiLoadToLoadListBaiVietToTable();
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListBaiViet();
          // Reset lại form
          resetFormEmployee();

        },
        error: function(paramError) {
          alert("Cập nhật bài viết thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm kiểm tra có trùng Department code hay không
    function checkDuplicateMaChuong(paramDepartmentCode) {
      var vIndex = 0;
      var vDuplicated = false;
      while (vIndex < gListChuong.length) {
        if (gListChuong[vIndex].maChuong == paramDepartmentCode && gActionChuong == gACTION_CREATE) {
          return true;
        }
        else if(gListChuong[vIndex].maChuong == paramDepartmentCode && gActionChuong == gACTION_UPDATE && gListChuong[vIndex].id != gChuongId) {
          return true;
        }
        else {
          vIndex++;
        }
      }
      return vDuplicated;
    }

    // Hàm kiểm tra mã nhân viên đã tồn tại hay chưa
    function checkDuplicateMaBai(paramPhotoCode) {
      var vIndex = 0;
      var vDuplicated = false;
      while (vIndex < gListBai.length) {
        // Nếu hành động thực hiện là tạo thì trả về true và có 1 code khác trùng thì trả về true
        if (gListBai[vIndex].maBai == paramPhotoCode && gActionBaiViet == gACTION_CREATE) {
          return true;
        }
        // Nếu hành động thực hiện là update mà có 1 code khác trùng nhưng khác vs ID cập nhật thì trả về true 
        else if(gListBai[vIndex].maBai == paramPhotoCode && gActionBaiViet == gACTION_UPDATE && gListBai[vIndex].id != gBaiId)
        {
          return true;
        }
        else {
          vIndex++;
        }
      }
      return vDuplicated;
    }


    // Hàm reset form employee
    function resetFormEmployee() {
      $("#inp-employee-code").val("");
      $("#inp-employee-name").val("");
      $("#inp-link").val("");
      $("#inp-position").val("");
    }

  </script>
</body>

</html>